;
; Module Description:
;    Sample kernel [.bin] Version 1.00
;    Copyright (c) 1998 MATTsoft, All rights reserved.
; Purpose:
;
;
        TITLE Sample kernel [.bin]
        NAME KERNEL
        LOCALS @@
        MODEL SMALL
        .286
;
CODE    SEGMENT BYTE PUBLIC 'CODE' USE16
        ASSUME CS:CODE,DS:CODE,ES:CODE
;
start:  mov ax,cs
        mov ds,ax
        mov es,ax

        mov si,offset message
        call showstr
        mov ax,cs
        call puthexw
        mov al,':'
	call putc
        mov ax,offset start
        call puthexw
        jmp $
;
showstr:
        lodsb
        or al,al
        jz @@1
        call putc
        jmp short showstr
@@1:    ret
;
putc:
        mov ah,0eh
        mov bx,7
        int 10h
        ret
;
puthexw:
        push ax
        shr ax,8
        call puthexb
        pop ax
        call puthexb
        ret
;
puthexb:
        push ax
        shr al,4
        call puthex_
        pop ax
        call puthex_
        ret
;
puthex_:
        and al,0fh
        cmp al,0ah
        jb @@1
        add al,('A'-0ah)-'0'
@@1:    add al,'0'
        call putc
        ret
;
message db 'This is example kernel.',13,10,13,10
        db 'I am loaded at ',0
;
CODE    ENDS
;
        END start
